(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



JInt::usage="JInt[varlist1,varlist2] returns basic one loop integrals \!\(\*SubsuperscriptBox[\(J\), \(\(\\\ \\\ \)\(bc .. \)\), \(a\)]\)(x,y,...), where varlist1={a,b,c,...} and varlist2=(x,y,...).";
CompositeF::usage="CompositeF[fun,varlist] returns numerically-ready composite function, where 'fun' is some function composed out of the basic integrals, and 'varlist' is list of function's arguments.";


Print["LOOL version: 1.0.2 (26 Aug 2014)."]
Print["http://lool.hepforge.org"]
Print["Authors: Luka Popov, Amon Ilakovac"]
Print["User manual: arXiv:1407.2727"]
Print["If you use LOOL in a scientific publication or talk, please give proper academic credit to us by citing our paper."]
Print["The package LOOL is written for Mathematica 8.0 (and higher) and it is distributed under the terms of GNU Public License, http://www.gnu.org/copyleft/gpl.html"]


JInt[varlist1_,varlist2_]:=Module[
{Omega,OFa,INT2,INT3,INT4,INT5,CteExtract2,CteExtract3,CteExtract4,CteExtract5,ProcInt2,ProcInt3, ProcInt4, ProcInt5,return,cte,av,bv,cv,dv,ev,xv,yv,zv,wv,RepRule},

If[Length[varlist1]==2,{av,bv}=varlist1];
If[Length[varlist1]==3,{av,bv,cv}=varlist1];
If[Length[varlist1]==4,{av,bv,cv,dv}=varlist1];
If[Length[varlist1]==5,{av,bv,cv,dv,ev}=varlist1];

If[Length[varlist2]==1,{xv}=varlist2];
If[Length[varlist2]==2,{xv,yv}=varlist2];
If[Length[varlist2]==3,{xv,yv,zv}=varlist2];
If[Length[varlist2]==4,{xv,yv,zv,wv}=varlist2];

Omega[D_]:=2*Pi^(D/2)/Gamma[D/2];

OFa[D_]:=I*Omega[D]*\[Mu]^(4-D)/(2*(2*Pi)^D);

INT2[a_,b_]:=(-1)^(a+b)*Assuming[{x>0,y>0,D<1},
Integrate[t^(D/2-1+a)/((t+x)^b) ,{t,0,\[Infinity]}]];

INT3[a_,b_,c_]:=(-1)^(a+b+c)*Assuming[{x>0,y>0,D<=2 (b+c-a+1)},Integrate[t^(D/2-1+a)/(((t+x)^b) ((t+y)^c)),{t,0,\[Infinity]}]];

INT4[a_,b_,c_,d_]:=(-1)^(a+b+c+d)*Assuming[{x>0,y>0,z>0,D<=2 (b+c+d-a-1)},Integrate[t^(D/2-1+a)/((t+x)^b (t+y)^c (t+z)^d),{t,0,\[Infinity]}]];

INT5[a_,b_,c_,d_,e_]:=(-1)^(a+b+c+d+e)*Assuming[{x>0,y>0,z>0,w>0,D<1},Integrate[t^(D/2-1+a)/((t+x)^b (t+y)^c (t+z)^d (t+w)^e),{t,0,\[Infinity]}]];

CteExtract2[expr_]:=Module[{},
expr/.Log[xv]->0/.xv^n__->0]/.xv->0;

CteExtract3[expr_]:=Module[{cstep1,cstep2,cstep3},
cstep1=Collect[Expand[expr/.Log[xv]->0],xv];
cstep2=cstep1/.xv^n__->0/.xv->0;
cstep3=cstep2/.Log[yv]->0/.yv^n__->0];

CteExtract4[expr_]:=Module[{cstep1,cstep2,cstep3,cstep4,cstep5},
cstep1=Collect[Expand[expr/.Log[xv]->0],xv];
cstep2=cstep1/.xv^n__->0/.xv->0;
cstep3=Collect[Expand[cstep2/.Log[yv]->0],yv];
cstep4=cstep3/.yv^n__->0/.yv->0;
cstep5=cstep4/.Log[zv]->0/.zv^n__->0];

CteExtract5[expr_]:=Module[{cstep1,cstep2,cstep3,cstep4,cstep5,cstep6,cstep7},
cstep1=Collect[Expand[expr/.Log[xv]->0],xv];
cstep2=cstep1/.xv^n__->0/.xv->0;
cstep3=Collect[Expand[cstep2/.Log[yv]->0],yv];
cstep4=cstep3/.yv^n__->0/.yv->0;
cstep5=Collect[Expand[cstep4/.Log[zv]->0],zv];
cstep6=cstep5/.zv^n__->0/.zv->0;
cstep7=cstep6/.Log[wv]->0/.wv^n__->0];

RepRule={x->xv,y->yv,z->zv,w->wv};

ProcInt2[a_,b_]:=Module[{step1,step2},
step1=Series[INT2[a,b]*OFa[D]*(16 \[Pi]^2)/I/.D->4-2 \[Epsilon],{\[Epsilon],0,0}]/.RepRule
//FullSimplify//Normal;
cte=CteExtract2[step1];
step2=step1-cte//FullSimplify];

ProcInt3[a_,b_,c_]:=Module[{step1,step2},
step1=Series[INT3[a,b,c]*OFa[D]*(16 \[Pi]^2)/I/.D->4-2 \[Epsilon],{\[Epsilon],0,0}]/.RepRule
//FullSimplify//Normal;
cte=CteExtract3[step1];
step2=step1-cte//FullSimplify];

ProcInt4[a_,b_,c_,d_]:=Module[{step1,step2},
step1=Series[INT4[a,b,c,d]*OFa[D]*(16 \[Pi]^2)/I/.D->4-2 \[Epsilon],{\[Epsilon],0,0}]/.RepRule
//FullSimplify//Normal;
cte=CteExtract4[step1];
step2=step1-cte//FullSimplify];

ProcInt5[a_,b_,c_,d_,e_]:=Module[{step1,step2},
step1=Series[INT5[a,b,c,d,e]*OFa[D]*(16 \[Pi]^2)/I/.D->4-2 \[Epsilon],{\[Epsilon],0,0}]/.RepRule
//FullSimplify//Normal;
cte=CteExtract5[step1];
step2=step1-cte//FullSimplify];

If[Length[varlist1]==2,
Return[{ProcInt2[av,bv],cte}]];

If[Length[varlist1]==3,
Return[{ProcInt3[av,bv,cv],cte}]];

If[Length[varlist1]==4,
Return[{ProcInt4[av,bv,cv,dv],cte}]];

If[Length[varlist1]==5,
Return[{ProcInt5[av,bv,cv,dv,ev],cte}]];
]


CompositeF[fun_,varlist_]:=Module[
{WhichDef1, WhichDef2,WhichDef3,WhichDef4,xv,yv,zv,wv,xQ,yQ,zQ,wQ,p},

If[Length[varlist]==1,{xv}=varlist];
If[Length[varlist]==2,{xv,yv}=varlist];
If[Length[varlist]==3,{xv,yv,zv}=varlist];
If[Length[varlist]==4,{xv,yv,zv,wv}=varlist];

WhichDef1[FB_,x_]:=Module[{FL},
FL[xx_]:=Limit[FB,x->xx];
Which[
(*1*) x==0,Evaluate[FL[0]],
(*2*) x==1,Evaluate[FL[1]],
(*3*) 0!=x!=1,Evaluate[FL[x]]]];

WhichDef2[FB_,x_,y_]:=Module[{FL},
FL[xx_,yy_]:=Limit[Limit[FB,x->xx],y->yy];
Which[
(*1*) x==y==0,Evaluate[FL[0,0]],
(*2*) x==0 && y==1,Evaluate[FL[0,1]],
(*3*) x==0,Evaluate[FL[0,y]],
(*4*) x==1 && y==0,Evaluate[FL[1,0]],
(*5*) x==y==1,Evaluate[FL[1,1]],
(*6*) x==1,Evaluate[FL[1,y]],
(*7*) y==0,Evaluate[FL[x,0]],
(*8*) y==1,Evaluate[FL[x,1]],
(*9*) x==y,Evaluate[FL[x,x]],
(*9a*) x!=y,Evaluate[FL[x,y]]]];

WhichDef3[FB_,x_,y_,z_]:=Module[{FL},
FL[xx_,yy_,zz_]:=Limit[Limit[Limit[FB,x->xx],y->yy],z->zz];
Which[
(*1*) x==y==z==0,Evaluate[FL[0,0,0]],
(*2*) x==y==0 && z==1,Evaluate[FL[0,0,1]],
(*3*) x==y==0,Evaluate[FL[0,0,z]],
(*4*) x==z==0 && y==1,Evaluate[FL[0,1,0]],
(*5*) x==0 && y==z==1,Evaluate[FL[0,1,1]],
(*6*) x==0 && y==1,Evaluate[FL[0,1,z]],
(*7*) x==z==0,Evaluate[FL[0,y,0]],
(*8*) x==0 && z==1,Evaluate[FL[0,y,1]],
(*9*) x==0 && y==z,Evaluate[FL[0,y,y]],
(*9a*) x==0,Evaluate[FL[0,y,z]],
(*10*) x==1 && y==z==0,Evaluate[FL[1,0,0]],
(*11*) x==z==1 && y==0,Evaluate[FL[1,0,1]],
(*12*) x==1 && y==0,Evaluate[FL[1,0,z]],
(*13*) x==y==1 && z==0,Evaluate[FL[1,1,0]],
(*14*) x==y==z==1,Evaluate[FL[1,1,1]],
(*15*) x==y==1,Evaluate[FL[1,1,z]],
(*16*) x==1 && z==0,Evaluate[FL[1,y,0]],
(*17*) x==z==1,Evaluate[FL[1,y,1]],
(*18*) x==1 && y==z,Evaluate[FL[1,y,y]],
(*18a*) x==1,Evaluate[FL[1,y,z]],
(*19*) y==z==0,Evaluate[FL[x,0,0]],
(*20*) y==0 && z==1,Evaluate[FL[x,0,1]],
(*21*) y==0 && x==z,Evaluate[FL[x,0,x]],
(*21a*) y==0,Evaluate[FL[x,0,z]],
(*22*) y==1 && z==0,Evaluate[FL[x,1,0]],
(*23*) y==1 && z==1,Evaluate[FL[x,1,1]],
(*24*) y==1 && x==z,Evaluate[FL[x,1,x]],
(*24a*) y==1,Evaluate[FL[x,1,z]],
(*25*) z==0 && x==y,Evaluate[FL[x,x,0]],
(*25a*) z==0,Evaluate[FL[x,y,0]],
(*26*) z==1 && x==y,Evaluate[FL[x,x,1]],
(*26a*) z==1,Evaluate[FL[x,y,1]],
(*27*) x==y==z,Evaluate[FL[x,x,x]],
(*27a*) x==y!=z,Evaluate[FL[x,x,z]],
(*27b*) x==z!=y,Evaluate[FL[x,y,x]],
(*27c*) x!=y==z,Evaluate[FL[x,y,y]],
(*27d*) x!=y!=z,Evaluate[FL[x,y,z]]]];

WhichDef4[FB_,x_,y_,z_,w_]:=Module[{FL},
FL[xx_,yy_,zz_,ww_]:=Limit[Limit[Limit[Limit[FB,x->xx],y->yy],z->zz],w->ww];
Which[
(*1*) x==y==z==w==0,Evaluate[FL[0,0,0,0]],
(*2*) x==y==z==0&&w==1,Evaluate[FL[0,0,0,1]],
(*3*) x==y==z==0,Evaluate[FL[0,0,0,w]],
(*4*) x==y==w==0&&z==1,Evaluate[FL[0,0,1,0]],
(*5*) x==y==0&&z==w==1,Evaluate[FL[0,0,1,1]],
(*6*) x==y==0&&z==1,Evaluate[FL[0,0,1,w]],
(*7*) x==y==w==0,Evaluate[FL[0,0,z,0]],
(*8*) x==y==0&&w==1,Evaluate[FL[0,0,z,1]],
(*9*) x==y==0&&z==w,Evaluate[FL[0,0,z,z]],
(*9a*) x==y==0,Evaluate[FL[0,0,z,w]],
(*10*) x==z==w==0&&y==1,Evaluate[FL[0,1,0,0]],
(*11*) x==z==0&&y==w==1,Evaluate[FL[0,1,0,1]],
(*12*) x==z==0&&y==1,Evaluate[FL[0,1,0,w]],
(*13*) x==w==0&&y==z==1,Evaluate[FL[0,1,1,0]],
(*14*) x==0&&y==z==w==1,Evaluate[FL[0,1,1,1]],
(*15*) x==0&&y==z==1,Evaluate[FL[0,1,1,w]],
(*16*) x==w==0&&y==1,Evaluate[FL[0,1,z,0]],
(*17*) x==0&&y==w==1,Evaluate[FL[0,1,z,1]],
(*18*) x==0&&y==1&&z==w,Evaluate[FL[0,1,z,z]],
(*18a*) x==0&&y==1,Evaluate[FL[0,1,z,w]],
(*19*) x==z==w==0,Evaluate[FL[0,y,0,0]],
(*20*) x==z==0&&w==1,Evaluate[FL[0,y,0,1]],
(*21*) x==z==0&&y==w,Evaluate[FL[0,y,0,y]],
(*21a*) x==z==0,Evaluate[FL[0,y,0,w]],
(*22*) x==w==0&&z==1,Evaluate[FL[0,y,1,0]],
(*23*) x==0&&z==w==1,Evaluate[FL[0,y,1,1]],
(*24*) x==0&&z==1&&y==w,Evaluate[FL[0,y,1,y]],
(*24a*) x==0&&z==1,Evaluate[FL[0,y,1,w]],
(*25*) x==w==0&&y==z,Evaluate[FL[0,y,y,0]],
(*25a*) x==w==0,Evaluate[FL[0,y,z,0]],
(*26*) x==0&&w==1&&y==z,Evaluate[FL[0,y,y,1]],
(*26a*) x==0&&w==1,Evaluate[FL[0,y,z,1]],
(*27*) x==0&&y==z==w,Evaluate[FL[0,y,y,y]],
(*27a*) x==0&&y==z!=w,Evaluate[FL[0,y,y,w]],
(*27b*) x==0&&y==w!=z,Evaluate[FL[0,y,z,y]],
(*27c*) x==0&&z==w!=y,Evaluate[FL[0,y,z,z]],
(*27d*) x==0,Evaluate[FL[0,y,z,w]],
(*28*) x==1&&y==z==w==0,Evaluate[FL[1,0,0,0]],
(*29*) x==w==1&&y==z==0,Evaluate[FL[1,0,0,1]],
(*30*) x==1&&y==z==0,Evaluate[FL[1,0,0,w]],
(*31*) x==z==1&&y==w==0,Evaluate[FL[1,0,1,0]],
(*32*) x==z==w==1&&y==0,Evaluate[FL[1,0,1,1]],
(*33*) x==z==1&&y==0,Evaluate[FL[1,0,1,w]],
(*34*) x==1&&y==w==0,Evaluate[FL[1,0,z,0]],
(*35*) x==w==1&&y==0,Evaluate[FL[1,0,z,1]],
(*36*) x==1&&y==0&&z==w,Evaluate[FL[1,0,z,z]],
(*36a*) x==1&&y==0,Evaluate[FL[1,0,z,w]],
(*37*) x==y==1&&z==w==0,Evaluate[FL[1,1,0,0]],
(*38*) x==y==w==1&&z==0,Evaluate[FL[1,1,0,1]],
(*39*) x==y==1&&z==0,Evaluate[FL[1,1,0,w]],
(*40*) x==y==z==1&&w==0,Evaluate[FL[1,1,1,0]],
(*41*) x==y==z==w==1,Evaluate[FL[1,1,1,1]],
(*42*) x==y==z==1,Evaluate[FL[1,1,1,w]],
(*43*) x==y==1&&w==0,Evaluate[FL[1,1,z,0]],
(*44*) x==y==w==1,Evaluate[FL[1,1,z,1]],
(*45*) x==y==1&&z==w,Evaluate[FL[1,1,z,z]],
(*45a*) x==y==1,Evaluate[FL[1,1,z,w]],
(*46*) x==1&&z==w==0,Evaluate[FL[1,y,0,0]],
(*47*) x==w==1&&z==0,Evaluate[FL[1,y,0,1]],
(*48*) x==1&&z==0&&y==w,Evaluate[FL[1,y,0,y]],
(*48a*) x==1&&z==0,Evaluate[FL[1,y,0,w]],
(*49*) x==z==1&&w==0,Evaluate[FL[1,y,1,0]],
(*50*) x==z==w==1,Evaluate[FL[1,y,1,1]],
(*51*) x==z==1&&y==w,Evaluate[FL[1,y,1,y]],
(*51a*) x==z==1,Evaluate[FL[1,y,1,w]],
(*52*) x==1&&w==0&&y==z,Evaluate[FL[1,y,y,0]],
(*52a*) x==1&&w==0,Evaluate[FL[1,y,z,0]],
(*53*) x==w==1&&y==z,Evaluate[FL[1,y,y,1]],
(*53a*) x==w==1,Evaluate[FL[1,y,z,1]],
(*54*) x==1&&y==z==w,Evaluate[FL[1,y,y,y]],
(*54a*) x==1&&y==z!=w,Evaluate[FL[1,y,y,w]],
(*54b*) x==1&&y==w!=z,Evaluate[FL[1,y,z,y]],
(*54c*) x==1&&z==w!=y,Evaluate[FL[1,y,z,z]],
(*54d*) x==1,Evaluate[FL[1,y,z,w]],
(*55*) y==z==w==0,Evaluate[FL[x,0,0,0]],
(*56*) y==z==0&&w==1,Evaluate[FL[x,0,0,1]],
(*57*) y==z==0&&x==w,Evaluate[FL[x,0,0,x]],
(*57a*) y==z==0,Evaluate[FL[x,0,0,w]],
(*58*) y==w==0&&z==1,Evaluate[FL[x,0,1,0]],
(*59*) y==0&&z==w==1,Evaluate[FL[x,0,1,1]],
(*60*) y==0&&z==1&&x==w,Evaluate[FL[x,0,1,x]],
(*60a*) y==0&&z==1,Evaluate[FL[x,0,1,w]],
(*61*) y==w==0&&x==z,Evaluate[FL[x,0,x,0]],
(*61a*) y==w==0,Evaluate[FL[x,0,z,0]],
(*62*) y==1&&w==1&&x==z,Evaluate[FL[x,1,x,1]],
(*62a*) y==1&&w==1,Evaluate[FL[x,1,z,1]],
(*63*) y==0&&x==z==w,Evaluate[FL[x,0,x,x]],
(*63a*) y==0&&x==z!=w,Evaluate[FL[x,0,x,w]],
(*63b*) y==0&&x==w!=x,Evaluate[FL[x,0,z,x]],
(*63c*) y==0&&z==w!=x,Evaluate[FL[x,0,z,z]],
(*63d*) y==0,Evaluate[FL[x,0,z,w]],
(*64*) y==1&&z==w==0,Evaluate[FL[x,1,0,0]],
(*65*) y==w==1&&z==0,Evaluate[FL[x,1,0,1]],
(*66*) y==1&&z==0&&x==w,Evaluate[FL[x,1,0,x]],
(*66a*) y==1&&z==0,Evaluate[FL[x,1,0,w]],
(*67*) y==z==1&&w==0,Evaluate[FL[x,1,1,0]],
(*68*) y==z==w==1,Evaluate[FL[x,1,1,1]],
(*69*) y==z==1&&x==w,Evaluate[FL[x,1,1,x]],
(*69a*) y==z==1,Evaluate[FL[x,1,1,w]],
(*70*) y==1&&w==0&&x==z,Evaluate[FL[x,1,x,0]],
(*70a*) y==1&&w==0,Evaluate[FL[x,1,z,0]],
(*71*) y==w==1&&x==z,Evaluate[FL[x,1,x,1]],
(*71a*) y==w==1,Evaluate[FL[x,1,z,1]],
(*72*) y==1&&x==y==z,Evaluate[FL[x,1,x,x]],
(*72a*) y==1&&x==z!=w,Evaluate[FL[x,1,x,w]],
(*72b*) y==1&&x==w!=z,Evaluate[FL[x,1,z,x]],
(*72c*) y==1&&w==z!=x,Evaluate[FL[x,1,z,z]],
(*72d*) y==1,Evaluate[FL[x,1,z,w]],
(*73*) z==w==0&&x==y,Evaluate[FL[x,x,0,0]],
(*73a*) z==w==0,Evaluate[FL[x,y,0,0]],
(*74*) z==0&&w==1&&x==y,Evaluate[FL[x,x,0,1]],
(*74a*) z==0&&w==1,Evaluate[FL[x,y,0,1]],
(*75*) z==0&&x==y==w,Evaluate[FL[x,x,0,x]],
(*75a*) z==0&&x==y!=w,Evaluate[FL[x,x,0,w]],
(*75b*) z==0&&x==w!=y,Evaluate[FL[x,y,0,x]],
(*75c*) z==0&&y==w!=x,Evaluate[FL[x,y,0,y]],
(*75d*) z==0,Evaluate[FL[x,y,0,w]],
(*76*) z==1&&w==0&&x==y,Evaluate[FL[x,x,1,0]],
(*76a*) z==1&&w==0,Evaluate[FL[x,y,1,0]],
(*77*) z==w==1&&x==y,Evaluate[FL[x,x,1,1]],
(*77a*) z==w==1,Evaluate[FL[x,y,1,1]],
(*78*) z==1&&x==y==w,Evaluate[FL[x,x,1,x]],
(*78a*) z==1&&x==y!=w,Evaluate[FL[x,x,1,w]],
(*78b*) z==1&&x==w!=y,Evaluate[FL[x,y,1,x]],
(*78c*) z==1&&y==w!=x,Evaluate[FL[x,y,1,y]],
(*78d*) z==1,Evaluate[FL[x,y,1,w]],
(*79*) w==0&&x==y==z,Evaluate[FL[x,x,x,0]],
(*79a*) w==0&&x==y!=z,Evaluate[FL[x,x,z,0]],
(*79b*) w==0&&x==z!=y,Evaluate[FL[x,y,x,0]],
(*79c*) w==0&&y==z!=x,Evaluate[FL[x,y,y,0]],
(*79d*) w==0,Evaluate[FL[x,y,z,0]],
(*80*) w==1&&x==y==z,Evaluate[FL[x,x,x,1]],
(*80a*) w==1&&x==y!=z,Evaluate[FL[x,x,z,1]],
(*80b*) w==1&&x==z!=y,Evaluate[FL[x,y,x,1]],
(*80c*) w==1&&z==y!=x,Evaluate[FL[x,y,y,1]],
(*80d*) w==1,Evaluate[FL[x,y,z,1]],
(*81*) x==y==z==w,Evaluate[FL[x,x,x,x]],
(*81a*) x==y==z!=w,Evaluate[FL[x,x,x,w]],
(*81b*) x==y==w!=z,Evaluate[FL[x,x,z,x]],
(*81c*) x==z==w!=y,Evaluate[FL[x,y,x,x]],
(*81d*) x!=y==z==w,Evaluate[FL[x,y,y,y]],
(*81e*) x==y!=z==w,Evaluate[FL[x,x,z,z]],
(*81f*) x==z!=y==w,Evaluate[FL[x,y,x,y]],
(*81g*) x==w!=y==z,Evaluate[FL[x,y,y,x]],
(*81h*) x==y!=z!=w,Evaluate[FL[x,x,z,w]],
(*81i*) x==z!=y!=w,Evaluate[FL[x,y,x,w]],
(*81j*) x==w!=y!=z,Evaluate[FL[x,y,z,x]],
(*81k*) y==z!=x!=w,Evaluate[FL[x,y,y,w]],
(*81l*) y==w!=x!=z,Evaluate[FL[x,y,z,y]],
(*81m*) z==w!=x!=y,Evaluate[FL[x,y,z,z]],
(*81n*) x!=y!=z!=w,Evaluate[FL[x,y,z,w]]]];

p=10^40;

If[Length[varlist]==1,
xQ=IntegerPart[Round[xv*p]]/p;
Return[Round[WhichDef1[fun,xv]*p]/p]/.xv->xQ
];

If[Length[varlist]==2,
xQ=Round[xv*p]/p;
yQ=Round[yv*p]/p;
Return[Round[WhichDef2[fun,xv,yv]*p]/p]/.{xv->xQ,yv->yQ}
];

If[Length[varlist]==3,
xQ=Round[xv*p]/p;
yQ=Round[yv*p]/p;
zQ=Round[zv*p]/p;
Return[Round[WhichDef3[fun,xv,yv,zv]*p]/p]/.{xv->xQ,yv->yQ,zv->zQ}
];

If[Length[varlist]==4,
xQ=Round[xv*p]/p;
yQ=Round[yv*p]/p;
zQ=Round[zv*p]/p;
wQ=Round[wv*p]/p;
Return[Round[WhichDef4[fun,xv,yv,zv,wv]*p]/p]/.{xv->xQ,yv->yQ,zv->zQ,wv->wQ}
];

];



